%define pkgname   kqemu
%define modname   qemu
%define modver    1.4.0
%define modrel    pre1
%define kernver   2.6.18-8.el5

%define modtop    extra
%define moddir    %{modtop}/%{modname}

%define PAE       1
%define xen       1


Summary:          The QEMU Accelerator Module
Name:             %{modname}-kmod
Version:          %{modver}
Release:          0.2.%{modrel}%{?dist}%{?pext}
License:          GPL
Group:            System Environment/Kernel
Source0:          http://www.nongnu.org/%{modname}/%{pkgname}-%{modver}%{modrel}.tar.gz
URL:              http://www.nongnu.org/%{modname}/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           Fabrice Bellard
ExclusiveArch:    i686 x86_64

%description
The QEMU Accelerator (KQEMU) is a driver allowing the QEMU PC emulator
to run much faster when emulating a PC on an x86 host. It is supported
on x86 or x86_64 Linux 2.4 or 2.6 hosts.


%package       -n kmod-%{modname}
Summary:          QEMU kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-%{_target_cpu} >= %{kernver}
Requires:         kernel
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod /sbin/weak-modules
Requires(preun):  /bin/rpm
Requires(postun): /sbin/depmod /sbin/weak-modules
BuildRequires:    kernel-devel-%{_target_cpu} = %{kernver}

%description   -n kmod-%{modname}
This package provides the QEMU kernel modules built for the Linux kernel
%{kernver} for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-PAE
Summary:          QEMU kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}PAE
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-%{_target_cpu} >= %{kernver}
Requires:         kernel-PAE
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod /sbin/weak-modules
Requires(preun):  /bin/rpm
Requires(postun): /sbin/depmod /sbin/weak-modules
%if %{PAE}
%ifarch i686
BuildRequires:    kernel-PAE-devel-%{_target_cpu} = %{kernver}
%endif
%endif

%description   -n kmod-%{modname}-PAE
This package provides the QEMU kernel modules built for the Linux kernel
%{kernver}PAE for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-xen
Summary:          QEMU kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}xen
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-%{_target_cpu} >= %{kernver}
Requires:         kernel-xen
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod /sbin/weak-modules
Requires(preun):  /bin/rpm
Requires(postun): /sbin/depmod /sbin/weak-modules
%if %{xen}
BuildRequires:    kernel-xen-devel-%{_target_cpu} = %{kernver}
%endif

%description   -n kmod-%{modname}-xen
This package provides the QEMU kernel modules built for the Linux kernel
%{kernver}xen for the %{_target_cpu} family of processors.


%prep
%setup -q -n %{pkgname}-%{modver}%{modrel}


%build
BuildModule() {
  # Prepare environment
  if [ -n "$2" ]; then
    echo "BUILDING MODULE FOR $2 $1 KERNEL..."
    config="$2-$1"
  else
    echo "BUILDING MODULE FOR up $1 KERNEL..."
    config="$1"
  fi

  # Build module
  %{__make} clean || :

  %configure \
	--kernel-path=%{_usrsrc}/kernels/%{kernver}-${config}

  %{__make} \
	all

  %{__mv} %{pkgname}.ko %{modname}-${config}.mod
}

%if %{PAE}
%ifarch i686
BuildModule %{_target_cpu} PAE
%endif
%endif

%if %{xen}
BuildModule %{_target_cpu} xen
%endif

BuildModule %{_target_cpu}

# Create modules config
echo "override %{pkgname} * weak-updates/%{modname}" >>%{pkgname}.conf


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/depmod.d
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}PAE/%{moddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}xen/%{moddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}/%{moddir}

%if %{PAE}
%ifarch i686
%{__install} -m 0744 %{modname}-PAE-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}PAE/%{moddir}/%{pkgname}.ko
%endif
%endif

%if %{xen}
%{__install} -m 0744 %{modname}-xen-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}xen/%{moddir}/%{pkgname}.ko
%endif

%{__install} -m 0744 %{modname}-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}/%{moddir}/%{pkgname}.ko

%{__install} -m 0644 %{pkgname}.conf ${RPM_BUILD_ROOT}%{_sysconfdir}/depmod.d


%post -n kmod-%{modname}
if [ -e "/boot/System.map-%{kernver}" ]; then
  /sbin/depmod -aeF /boot/System.map-%{kernver} %{kernver} >/dev/null || :
fi

MODULES=($(find /lib/modules/%{kernver}/%{moddir} | grep '\.ko$'))
if [ -x "/sbin/weak-modules" ]; then
  printf '%s\n' "${MODULES[@]}" | /sbin/weak-modules --add-modules
fi

%post -n kmod-%{modname}-PAE
if [ -e "/boot/System.map-%{kernver}PAE" ]; then
  /sbin/depmod -aeF /boot/System.map-%{kernver}PAE %{kernver}PAE >/dev/null || :
fi

MODULES=($(find /lib/modules/%{kernver}PAE/%{moddir} | grep '\.ko$'))
if [ -x "/sbin/weak-modules" ]; then
  printf '%s\n' "${MODULES[@]}" | /sbin/weak-modules --add-modules
fi

%post -n kmod-%{modname}-xen
if [ -e "/boot/System.map-%{kernver}xen" ]; then
  /sbin/depmod -aeF /boot/System.map-%{kernver}xen %{kernver}xen >/dev/null || :
fi

MODULES=($(find /lib/modules/%{kernver}xen/%{moddir} | grep '\.ko$'))
if [ -x "/sbin/weak-modules" ]; then
  printf '%s\n' "${MODULES[@]}" | /sbin/weak-modules --add-modules
fi


%preun -n kmod-%{modname}
rpm -ql kmod-%{modname} | grep '\.ko$' >%{_localstatedir}/run/rpm-kmod-%{modname}-modules

%preun -n kmod-%{modname}-PAE
rpm -ql kmod-%{modname}-PAE | grep '\.ko$' >%{_localstatedir}/run/rpm-kmod-%{modname}-PAE-modules

%preun -n kmod-%{modname}-xen
rpm -ql kmod-%{modname}-xen | grep '\.ko$' >%{_localstatedir}/run/rpm-kmod-%{modname}-xen-modules


%postun -n kmod-%{modname}
/sbin/depmod -aF /boot/System.map-%{kernver} %{kernver} &>/dev/null || :

MODULES=($(cat %{_localstatedir}/run/rpm-kmod-%{modname}-modules))
if [ -x "/sbin/weak-modules" ]; then
  printf '%s\n' "${MODULES[@]}" | /sbin/weak-modules --remove-modules
fi

%postun -n kmod-%{modname}-PAE
/sbin/depmod -aF /boot/System.map-%{kernver}PAE %{kernver}PAE &>/dev/null || :

MODULES=($(cat %{_localstatedir}/run/rpm-kmod-%{modname}-PAE-modules))
if [ -x "/sbin/weak-modules" ]; then
  printf '%s\n' "${MODULES[@]}" | /sbin/weak-modules --remove-modules
fi

%postun -n kmod-%{modname}-xen
/sbin/depmod -aF /boot/System.map-%{kernver}xen %{kernver}xen &>/dev/null || :

MODULES=($(cat %{_localstatedir}/run/rpm-kmod-%{modname}-xen-modules))
if [ -x "/sbin/weak-modules" ]; then
  printf '%s\n' "${MODULES[@]}" | /sbin/weak-modules --remove-modules
fi


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files -n kmod-%{modname}
%defattr(644,root,root)
%config %{_sysconfdir}/depmod.d/%{pkgname}.conf
%defattr(744,root,root)
/lib/modules/%{kernver}

%if %{PAE}
%ifarch i686
%files -n kmod-%{modname}-PAE
%defattr(644,root,root)
%config %{_sysconfdir}/depmod.d/%{pkgname}.conf
%defattr(744,root,root)
/lib/modules/%{kernver}PAE
%endif
%endif

%if %{xen}
%files -n kmod-%{modname}-xen
%defattr(644,root,root)
%config %{_sysconfdir}/depmod.d/%{pkgname}.conf
%defattr(744,root,root)
/lib/modules/%{kernver}xen
%endif


%changelog
* Sat Oct 17 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.4.0-0.2.pre1
- RHEL5 supports weak modules, does not require per-kernel builds

* Wed Sep 16 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.4.0-0.1.pre1.2.6.18_164.el5
- New kernel version (2.6.18-164.el5)

* Sun Sep 06 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.4.0-0.1.pre1.2.6.18_128.7.1.el5
- New version (1.4.0pre1)

* Tue Aug 25 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.7.1.el5
- New kernel version (2.6.18-128.7.1.el5)

* Thu Aug 06 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.4.1.el5
- New kernel version (2.6.18-128.4.1.el5)

* Wed Jul 15 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.2.1.el5
- New kernel version (2.6.18-128.2.1.el5)

* Wed Jul 01 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.16.el5
- New kernel version (2.6.18-128.1.16.el5)

* Sun Jun 21 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.14.el5
- New kernel version (2.6.18-128.1.14.el5)

* Fri May 08 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.10.el5
- New kernel version (2.6.18-128.1.10.el5)

* Fri Apr 03 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.6.el5
- New kernel version (2.6.18-128.1.6.el5)

* Fri Apr 03 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.1.el5
- New kernel version (2.6.18-128.1.1.el5)

* Fri Apr 03 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.el5
- New kernel version (2.6.18-128.el5)

* Fri Dec 19 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.22.el5
- New kernel version (2.6.18-92.1.22.el5)

* Fri Nov 14 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.18.el5
- New kernel version (2.6.18-92.1.18.el5)

* Sat Nov 08 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.17.el5
- New kernel version (2.6.18-92.1.17.el5)

* Mon Oct 27 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.13.el5
- New kernel version (2.6.18-92.1.13.el5)

* Mon Oct 27 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.10.el5
- New kernel version (2.6.18-92.1.10.el5)

* Mon Oct 27 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.6.el5
- Initial build
